diff --git a/src/main/java/net/minecraft/core/entity/EntityPainting.java b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
similarity index 67%
rename from src/main/java/net/minecraft/core/entity/EntityPainting.java
rename to src/main/java/net/minecraft/core/entity/PaintingEntity.java
index 4f21e75d5..062487d35 100644
--- a/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.entity;
 
 import net.minecraft.core.Global;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.Packet25EntityPainting;
+import net.minecraft.core.net.packet.AddPaintingPacket;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.server.MinecraftServer;
@@ -20,13 +20,20 @@ import java.util.*;
 
 // Referenced classes of package net.minecraft.src:
 //            Entity, ArtType, AxisAlignedBB, World,
-//            EntityItem, ItemStack, Item, MathHelper, 
+//            ItemEntity, ItemStack, Item, MathHelper,
 //            Material, NBTTagCompound
 
-public class EntityPainting extends Entity
+public class PaintingEntity extends Entity
 {
+    private int updateCounter;
+    public int direction;
+    public int blockX;
+    public int blockY;
+    public int blockZ;
+    public ItemStack borderStack;
+    public ArtType art;
 
-    public EntityPainting(World world)
+    public PaintingEntity(World world)
     {
         super(world);
         updateCounter = 0;
@@ -42,22 +49,20 @@ public class EntityPainting extends Entity
         return true;
     }
 
-    public EntityPainting(World world, int x, int y, int z, int side, String motive)
+    public PaintingEntity(World world, int x, int y, int z, int side, String motive)
     {
         this(world);
-        xPosition = x;
-        yPosition = y;
-        zPosition = z;
+        blockX = x;
+        blockY = y;
+        blockZ = z;
 
         art = ArtType.map.getOrDefault(motive, art);
         setDirection(side);
     }
 
     @Override
-    protected void init()
+    protected void defineSynchedData()
     {
-        entityData.define(1, -1);
-        entityData.define(2, -1);
     }
 
     public void setDirection(int direction)
@@ -77,9 +82,9 @@ public class EntityPainting extends Entity
         sizeX /= 32F;
         sizeY /= 32F;
         sizeZ /= 32F;
-        double centerX = (double)xPosition + 0.5D;
-        double centerY = (double)yPosition + 0.5D;
-        double centerZ = (double)zPosition + 0.5D;
+        double centerX = (double) blockX + 0.5D;
+        double centerY = (double) blockY + 0.5D;
+        double centerZ = (double) blockZ + 0.5D;
         float offsetFromWall = 0.5F + 0.03F;
         if(direction == 0)
         {
@@ -116,7 +121,7 @@ public class EntityPainting extends Entity
         centerY += offsetFromCenter(art.sizeY);
         setPos(centerX, centerY, centerZ);
         float expand = -0.00F;
-        bb.setBounds(centerX - sizeX - expand, centerY - sizeY - expand, centerZ - sizeZ - expand, centerX + sizeX + expand, centerY + sizeY + expand, centerZ + sizeZ + expand);
+        bb.set(centerX - sizeX - expand, centerY - sizeY - expand, centerZ - sizeZ - expand, centerX + sizeX + expand, centerY + sizeY + expand, centerZ + sizeZ + expand);
         if (direction == 0 || direction == 2)
         {
             bb.minZ -= 0.01f;
@@ -144,18 +149,18 @@ public class EntityPainting extends Entity
         if(updateCounter++ == 100 && !world.isClientSide)
         {
             updateCounter = 0;
-            if(!canFitPainting())
+            if(!canStay())
             {
                 remove();
-                world.entityJoinedWorld(new EntityItem(world, x, y, z, new ItemStack(Item.painting)));
+                world.entityJoinedWorld(new ItemEntity(world, x, y, z, new ItemStack(Items.PAINTING)));
                 if (getBorderStack() != null){
-                    this.world.entityJoinedWorld(new EntityItem(this.world, this.x, this.y, this.z, getBorderStack()));
+                    this.world.entityJoinedWorld(new ItemEntity(this.world, this.x, this.y, this.z, getBorderStack()));
                 }
             }
         }
     }
 
-    public boolean canFitPainting()
+    public boolean canStay()
     {
         if(!world.getCubes(this, bb).isEmpty())
         {
@@ -163,26 +168,26 @@ public class EntityPainting extends Entity
         }
         int xSize = art.sizeX / 16;
         int ySize = art.sizeY / 16;
-        int xPosition = this.xPosition;
-        int yPosition = this.yPosition;
-        int zPosition = this.zPosition;
+        int xPosition = this.blockX;
+        int yPosition = this.blockY;
+        int zPosition = this.blockZ;
         if(direction == 0)
         {
-            xPosition = MathHelper.floor_double(x - (double)((float)art.sizeX / 32F));
+            xPosition = MathHelper.floor(x - (double)((float)art.sizeX / 32F));
         }
         if(direction == 1)
         {
-            zPosition = MathHelper.floor_double(z - (double)((float)art.sizeX / 32F));
+            zPosition = MathHelper.floor(z - (double)((float)art.sizeX / 32F));
         }
         if(direction == 2)
         {
-            xPosition = MathHelper.floor_double(x - (double)((float)art.sizeX / 32F));
+            xPosition = MathHelper.floor(x - (double)((float)art.sizeX / 32F));
         }
         if(direction == 3)
         {
-            zPosition = MathHelper.floor_double(z - (double)((float)art.sizeX / 32F));
+            zPosition = MathHelper.floor(z - (double)((float)art.sizeX / 32F));
         }
-        yPosition = MathHelper.floor_double(y - (double)((float)art.sizeY / 32F));
+        yPosition = MathHelper.floor(y - (double)((float)art.sizeY / 32F));
         for(int dx = 0; dx < xSize; dx++)
         {
             for(int dy = 0; dy < ySize; dy++)
@@ -190,11 +195,11 @@ public class EntityPainting extends Entity
                 Material material;
                 if(direction == 0 || direction == 2)
                 {
-                    material = world.getBlockMaterial(xPosition + dx, yPosition + dy, this.zPosition);
+                    material = world.getBlockMaterial(xPosition + dx, yPosition + dy, this.blockZ);
                 }
                 else
                 {
-                    material = world.getBlockMaterial(this.xPosition, yPosition + dy, zPosition + dx);
+                    material = world.getBlockMaterial(this.blockX, yPosition + dy, zPosition + dx);
                 }
                 if(!material.isSolid())
                 {
@@ -207,7 +212,7 @@ public class EntityPainting extends Entity
         List<Entity> entities = world.getEntitiesWithinAABBExcludingEntity(this, bb);
         for (Entity entity : entities)
         {
-            if (entity instanceof EntityPainting)
+            if (entity instanceof PaintingEntity)
             {
                 return false;
             }
@@ -229,14 +234,14 @@ public class EntityPainting extends Entity
         {
             remove();
             markHurt();
-            if (!(entity instanceof EntityPlayer) || ((EntityPlayer) entity).getGamemode().dropBlockOnBreak())
+            if (!(entity instanceof Player) || ((Player) entity).getGamemode().dropBlockOnBreak())
             {
-                world.entityJoinedWorld(new EntityItem(world, x, y, z, new ItemStack(Item.painting)));
+                world.entityJoinedWorld(new ItemEntity(world, x, y, z, new ItemStack(Items.PAINTING)));
                 if (getBorderStack() != null){
-                    this.world.entityJoinedWorld(new EntityItem(this.world, this.x, this.y, this.z, getBorderStack()));
+                    this.world.entityJoinedWorld(new ItemEntity(this.world, this.x, this.y, this.z, getBorderStack()));
                 }
             }
-            world.playBlockSoundEffect(null, this.x, this.y + heightOffset, this.z, Block.planksOak, EnumBlockSoundEffectType.MINE);
+            world.playBlockSoundEffect(null, this.x, this.y + heightOffset, this.z, Blocks.PLANKS_OAK, EnumBlockSoundEffectType.MINE);
         }
         return true;
     }
@@ -246,9 +251,9 @@ public class EntityPainting extends Entity
     {
         tag.putByte("Dir", (byte)direction);
         tag.putString("Motive", art.key);
-        tag.putInt("TileX", xPosition);
-        tag.putInt("TileY", yPosition);
-        tag.putInt("TileZ", zPosition);
+        tag.putInt("TileX", blockX);
+        tag.putInt("TileY", blockY);
+        tag.putInt("TileZ", blockZ);
         ItemStack stack = getBorderStack();
         if (stack != null){
             tag.putBoolean("itemExists", true);
@@ -263,9 +268,9 @@ public class EntityPainting extends Entity
 	public void readAdditionalSaveData(CompoundTag tag)
     {
         direction = tag.getByte("Dir");
-        xPosition = tag.getInteger("TileX");
-        yPosition = tag.getInteger("TileY");
-        zPosition = tag.getInteger("TileZ");
+        blockX = tag.getInteger("TileX");
+        blockY = tag.getInteger("TileY");
+        blockZ = tag.getInteger("TileZ");
         String motive = tag.getString("Motive");
         art = ArtType.map.getOrDefault(motive, ArtType.Kebab);
         setDirection(direction);
@@ -284,7 +289,7 @@ public class EntityPainting extends Entity
         if(!world.isClientSide && xd * xd + yd * yd + zd * zd > 0.0D)
         {
             remove();
-            world.entityJoinedWorld(new EntityItem(world, x, y, z, new ItemStack(Item.painting)));
+            world.entityJoinedWorld(new ItemEntity(world, x, y, z, new ItemStack(Items.PAINTING)));
         }
     }
 
@@ -294,12 +299,12 @@ public class EntityPainting extends Entity
         if(!world.isClientSide && x * x + y * y + z * z > 0.0D)
         {
             remove();
-            world.entityJoinedWorld(new EntityItem(world, this.x, this.y, this.z, new ItemStack(Item.painting)));
+            world.entityJoinedWorld(new ItemEntity(world, this.x, this.y, this.z, new ItemStack(Items.PAINTING)));
         }
     }
 
     @Override
-    public boolean interact(EntityPlayer player) {
+    public boolean interact(Player player) {
         if (player.getHeldItem() != null){
             ItemStack stack = player.getHeldItem();
             ItemStack paintingStack = getBorderStack();
@@ -307,7 +312,7 @@ public class EntityPainting extends Entity
             setStack(new ItemStack(stack.getItem(), 1, stack.getMetadata()));
             stack.consumeItem(player);
             if (stack.stackSize <= 0) {
-                player.inventory.setInventorySlotContents(player.inventory.currentItem, null);
+                player.inventory.setItem(player.inventory.currentItem, null);
             }
             if (paintingStack != null && player.getGamemode().consumeBlocks()){
                 player.inventory.insertItem(paintingStack, true);
@@ -332,7 +337,7 @@ public class EntityPainting extends Entity
     public void setStack(ItemStack stack){
         borderStack = stack;
         if (Global.isServer){
-            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new Packet25EntityPainting(this), world.dimension.id);
+            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new AddPaintingPacket(this), world.dimension.id);
         }
     }
     private static final HashMap<String, NamespaceID> borderMaterialMap = new HashMap<>();
@@ -343,20 +348,13 @@ public class EntityPainting extends Entity
         return borderMaterialMap.get(stack.itemID + "|" + stack.getMetadata());
     }
     static {
-        addBorder(Item.ingotIron.getDefaultStack(), new NamespaceID("minecraft", "border_iron"));
-        addBorder(Item.ingotGold.getDefaultStack(), new NamespaceID("minecraft", "border_gold"));
-        addBorder(Item.ingotSteel.getDefaultStack(), new NamespaceID("minecraft", "border_steel"));
-        addBorder(new ItemStack(Item.dye, 1, 4), new NamespaceID("minecraft", "border_lapis"));
-        addBorder(Item.diamond.getDefaultStack(), new NamespaceID("minecraft", "border_diamond"));
-        addBorder(Item.dustRedstone.getDefaultStack(), new NamespaceID("minecraft", "border_redstone"));
-        addBorder(Item.olivine.getDefaultStack(), new NamespaceID("minecraft", "border_olivine"));
-        addBorder(Item.quartz.getDefaultStack(), new NamespaceID("minecraft", "border_quartz"));
+        addBorder(Items.INGOT_IRON.getDefaultStack(), new NamespaceID("minecraft", "border_iron"));
+        addBorder(Items.INGOT_GOLD.getDefaultStack(), new NamespaceID("minecraft", "border_gold"));
+        addBorder(Items.INGOT_STEEL.getDefaultStack(), new NamespaceID("minecraft", "border_steel"));
+        addBorder(new ItemStack(Items.DYE, 1, 4), new NamespaceID("minecraft", "border_lapis"));
+        addBorder(Items.DIAMOND.getDefaultStack(), new NamespaceID("minecraft", "border_diamond"));
+        addBorder(Items.DUST_REDSTONE.getDefaultStack(), new NamespaceID("minecraft", "border_redstone"));
+        addBorder(Items.OLIVINE.getDefaultStack(), new NamespaceID("minecraft", "border_olivine"));
+        addBorder(Items.QUARTZ.getDefaultStack(), new NamespaceID("minecraft", "border_quartz"));
     }
-    private int updateCounter;
-    public int direction;
-    public int xPosition;
-    public int yPosition;
-    public int zPosition;
-    public ItemStack borderStack;
-    public ArtType art;
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityPathfinder.java b/src/main/java/net/minecraft/core/entity/PathfinderMob.java
similarity index 77%
rename from src/main/java/net/minecraft/core/entity/EntityPathfinder.java
rename to src/main/java/net/minecraft/core/entity/PathfinderMob.java
index ee37a1b09..a4c968ce2 100644
--- a/src/main/java/net/minecraft/core/entity/EntityPathfinder.java
+++ b/src/main/java/net/minecraft/core/entity/PathfinderMob.java
@@ -1,21 +1,26 @@
 package net.minecraft.core.entity;
 
 // Referenced classes of package net.minecraft.src:
-//            EntityLiving, World, Entity, AxisAlignedBB, 
+//            Mob, World, Entity, AxisAlignedBB,
 //            MathHelper, PathEntity, Vec3D
 
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.pathfinder.Path;
-import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 import java.util.List;
 
-public abstract class EntityPathfinder extends EntityLiving
+public abstract class PathfinderMob extends Mob
 {
+    private static final int MAX_TURN = 30;
+    protected Path pathToEntity;
+    protected Entity entityToAttack;
+    protected Entity closestFireflyEntity;
+    protected boolean hasAttacked;
 
-    public EntityPathfinder(World world)
+    public PathfinderMob(World world)
     {
         super(world);
         hasAttacked = false;
@@ -27,7 +32,7 @@ public abstract class EntityPathfinder extends EntityLiving
     }
 
     @Override
-	protected void updatePlayerActionState()
+	protected void updateAI()
     {
         hasAttacked = isMovementCeased();
         float sightRadius = 16F;
@@ -63,18 +68,18 @@ public abstract class EntityPathfinder extends EntityLiving
             // random roaming
             roamRandomPath();
         }
-        int i = MathHelper.floor_double(bb.minY + 0.5D);
+        int i = MathHelper.floor(bb.minY + 0.5D);
         boolean inWater = isInWater();
         boolean inLava = isInLava();
         xRot = 0.0F;
         if(pathToEntity == null || random.nextInt(100) == 0)
         {
-            super.updatePlayerActionState();
+            super.updateAI();
             pathToEntity = null;
             return;
         }
-        Vec3d coordsForNextPath = pathToEntity.getPos(this);
-        for(double d = bbWidth * 2.0F; coordsForNextPath != null && coordsForNextPath.squareDistanceTo(x, coordsForNextPath.yCoord, z) < d * d;)
+        Vec3 coordsForNextPath = pathToEntity.getPos(this);
+        for(double d = bbWidth * 2.0F; coordsForNextPath != null && coordsForNextPath.distanceToSquared(x, coordsForNextPath.y, z) < d * d;)
         {
             pathToEntity.next();
             if(pathToEntity.isDone())
@@ -91,23 +96,23 @@ public abstract class EntityPathfinder extends EntityLiving
         isJumping = false;
         if(coordsForNextPath != null)
         {
-            double x1 = coordsForNextPath.xCoord - x;
-            double z1 = coordsForNextPath.zCoord - z;
-            double y1 = coordsForNextPath.yCoord - (double)i;
-            float f2 = (float)((java.lang.Math.atan2(z1, x1) * 180D) / 3.1415927410125732D) - 90F;
+            double x1 = coordsForNextPath.x - x;
+            double z1 = coordsForNextPath.z - z;
+            double y1 = coordsForNextPath.y - (double)i;
+            float f2 = (float)((java.lang.Math.atan2(z1, x1) * 180D) / Math.PI) - 90F;
             float f3 = f2 - yRot;
 
             //move forward towards path
             moveForward = moveSpeed;
             for(; f3 < -180F; f3 += 360F) { }
             for(; f3 >= 180F; f3 -= 360F) { }
-            if(f3 > 30F)
+            if(f3 > MAX_TURN)
             {
-                f3 = 30F;
+                f3 = MAX_TURN;
             }
-            if(f3 < -30F)
+            if(f3 < -MAX_TURN)
             {
-                f3 = -30F;
+                f3 = -MAX_TURN;
             }
             yRot += f3;
             if(hasAttacked && entityToAttack != null)
@@ -115,8 +120,8 @@ public abstract class EntityPathfinder extends EntityLiving
                 double d4 = entityToAttack.x - x;
                 double d5 = entityToAttack.z - z;
                 float f5 = yRot;
-                yRot = (float)((java.lang.Math.atan2(d5, d4) * 180D) / 3.1415927410125732D) - 90F;
-                float f4 = (((f5 - yRot) + 90F) * 3.141593F) / 180F;
+                yRot = (float)((java.lang.Math.atan2(d5, d4) * 180D) / Math.PI) - 90F;
+                float f4 = (((f5 - yRot) + 90F) * MathHelper.PI) / 180F;
                 moveStrafing = -MathHelper.sin(f4) * moveForward * 1.0F;
                 moveForward = MathHelper.cos(f4) * moveForward * 1.0F;
             }
@@ -127,7 +132,7 @@ public abstract class EntityPathfinder extends EntityLiving
         }
         if(entityToAttack != null)
         {
-            faceEntity(entityToAttack, 30F, 30F);
+            lookAt(entityToAttack, 30F, 30F);
         }
         if(horizontalCollision && !hasPath())
         {
@@ -140,7 +145,7 @@ public abstract class EntityPathfinder extends EntityLiving
     }
 
     protected Entity getClosestFireflyToEntity (int x, int y, int z, float radius){
-        List<Entity> nearbyFireflies = world.getEntitiesWithinAABB(EntityFireflyCluster.class, AABB.getBoundingBoxFromPool(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).expand(radius, 4D, radius));
+        List<Entity> nearbyFireflies = world.getEntitiesWithinAABB(FireflyClusterMob.class, AABB.getTemporaryBB(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(radius, 4D, radius));
 
         double closestDistance = -1D;
         Entity cluster = null;
@@ -166,9 +171,9 @@ public abstract class EntityPathfinder extends EntityLiving
         float bestPathWeight = -99999F;
         for(int l = 0; l < 10; l++)
         {
-            int x1 = MathHelper.floor_double((this.x + (double) random.nextInt(13)) - 6D);
-            int y1 = MathHelper.floor_double((this.y + (double) random.nextInt(7)) - 3D);
-            int z1 = MathHelper.floor_double((this.z + (double) random.nextInt(13)) - 6D);
+            int x1 = MathHelper.floor((this.x + (double) random.nextInt(13)) - 6D);
+            int y1 = MathHelper.floor((this.y + (double) random.nextInt(7)) - 3D);
+            int z1 = MathHelper.floor((this.z + (double) random.nextInt(13)) - 6D);
             float currentPathWeight = getBlockPathWeight(x1, y1, z1);
             if(currentPathWeight > bestPathWeight)
             {
@@ -205,12 +210,12 @@ public abstract class EntityPathfinder extends EntityLiving
     }
 
     @Override
-	public boolean getCanSpawnHere()
+	public boolean canSpawnHere()
     {
-        int i = MathHelper.floor_double(x);
-        int j = MathHelper.floor_double(bb.minY);
-        int k = MathHelper.floor_double(z);
-        return super.getCanSpawnHere() && getBlockPathWeight(i, j, k) >= 0.0F;
+        int i = MathHelper.floor(x);
+        int j = MathHelper.floor(bb.minY);
+        int k = MathHelper.floor(z);
+        return super.canSpawnHere() && getBlockPathWeight(i, j, k) >= 0.0F;
     }
 
     public boolean hasPath()
@@ -233,8 +238,5 @@ public abstract class EntityPathfinder extends EntityLiving
         entityToAttack = entity;
     }
 
-    protected Path pathToEntity;
-    protected Entity entityToAttack;
-    protected Entity closestFireflyEntity;
-    protected boolean hasAttacked;
+
 }
diff --git a/src/main/java/net/minecraft/core/entity/SkinVariantList.java b/src/main/java/net/minecraft/core/entity/SkinVariantList.java
index 90539d563..30549e9d5 100644
--- a/src/main/java/net/minecraft/core/entity/SkinVariantList.java
+++ b/src/main/java/net/minecraft/core/entity/SkinVariantList.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.entity;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 public abstract class SkinVariantList {
-    public abstract int getNumSkinsForEntity(Class<? extends Entity> entityClass);
+    public abstract @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex);
 
-    public int getRandomSkinForEntity(Class<? extends Entity> entityClass) {
-        int maxSkins = getNumSkinsForEntity(entityClass);
-        return maxSkins > 1 ? (int) (Math.random() * maxSkins) : 0;
-    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityTNT.java b/src/main/java/net/minecraft/core/entity/TNTPrimedEntity.java
similarity index 76%
rename from src/main/java/net/minecraft/core/entity/EntityTNT.java
rename to src/main/java/net/minecraft/core/entity/TNTPrimedEntity.java
index 0e64d0771..718180d5d 100644
--- a/src/main/java/net/minecraft/core/entity/EntityTNT.java
+++ b/src/main/java/net/minecraft/core/entity/TNTPrimedEntity.java
@@ -8,10 +8,11 @@ import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
-public class EntityTNT extends Entity
+public class TNTPrimedEntity extends Entity
 {
+    public int fuse;
 
-    public EntityTNT(World world)
+    public TNTPrimedEntity(World world)
     {
         super(world);
         fuse = 0;
@@ -20,14 +21,14 @@ public class EntityTNT extends Entity
         heightOffset = bbHeight / 2.0F;
     }
 
-    public EntityTNT(World world, double d, double d1, double d2)
+    public TNTPrimedEntity(World world, double d, double d1, double d2)
     {
         this(world);
         setPos(d, d1, d2);
-        float f = (float)(java.lang.Math.random() * 3.1415927410125732D * 2D);
-        xd = -MathHelper.sin((f * 3.141593F) / 180F) * 0.02F;
-        yd = 0.20000000298023224D;
-        zd = -MathHelper.cos((f * 3.141593F) / 180F) * 0.02F;
+        float f = (float)(java.lang.Math.random() * Math.PI * 2D);
+        xd = -MathHelper.sin((f * MathHelper.PI) / 180F) * 0.02F;
+        yd = 0.2D;
+        zd = -MathHelper.cos((f * MathHelper.PI) / 180F) * 0.02F;
         fuse = 80;
         xo = d;
         yo = d1;
@@ -35,7 +36,7 @@ public class EntityTNT extends Entity
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
     }
 
@@ -75,7 +76,7 @@ public class EntityTNT extends Entity
             if(!world.isClientSide)
             {
                 remove();
-                explode();
+                world.createExplosion(null, x, y, z, 4);
             } else
             {
                 remove();
@@ -86,12 +87,6 @@ public class EntityTNT extends Entity
         }
     }
 
-    private void explode()
-    {
-        float f = 4F;
-        world.createExplosion(null, x, y, z, f);
-    }
-
     @Override
     public void addAdditionalSaveData(CompoundTag tag)
     {
@@ -109,6 +104,4 @@ public class EntityTNT extends Entity
     {
         return 0.0F;
     }
-
-    public int fuse;
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java b/src/main/java/net/minecraft/core/entity/animal/Animal.java
similarity index 74%
rename from src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java
rename to src/main/java/net/minecraft/core/entity/animal/Animal.java
index 44c454c83..eabf88600 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/Animal.java
@@ -2,22 +2,23 @@ package net.minecraft.core.entity.animal;
 
 
 // Referenced classes of package net.minecraft.src:
-//            EntityCreature, World, Block, BlockGrass, 
+//            EntityCreature, World, Block, GrassBlock,
 //            MathHelper, AxisAlignedBB, NBTTagCompound
 
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.EntityPathfinder;
+import net.minecraft.core.entity.PathfinderMob;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.season.Seasons;
 
-public abstract class EntityAnimal extends EntityPathfinder
-	implements IAnimal
+public abstract class Animal extends PathfinderMob
+	implements Creature
 {
 
-    public EntityAnimal(World world)
+    public Animal(World world)
     {
         super(world);
         scoreValue = 10;
@@ -36,7 +37,7 @@ public abstract class EntityAnimal extends EntityPathfinder
     @Override
 	protected float getBlockPathWeight(int x, int y, int z)
     {
-        if(world.getBlockId(x, y - 1, z) == Block.grass.id)
+        if(world.getBlockId(x, y - 1, z) == Blocks.GRASS.id)
         {
             return 10F;
         } else
@@ -58,21 +59,21 @@ public abstract class EntityAnimal extends EntityPathfinder
     }
 
     @Override
-	public boolean getCanSpawnHere()
+	public boolean canSpawnHere()
     {
-        int x = MathHelper.floor_double(this.x);
-        int y = MathHelper.floor_double(bb.minY);
-        int z = MathHelper.floor_double(this.z);
+        int x = MathHelper.floor(this.x);
+        int y = MathHelper.floor(bb.minY);
+        int z = MathHelper.floor(this.z);
         int id = world.getBlockId(x, y - 1, z);
         if (Block.blocksList[id] != null)
         {
-            return Block.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && world.getFullBlockLightValue(x, y, z) > 8 && super.getCanSpawnHere();
+            return Block.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && world.getFullBlockLightValue(x, y, z) > 8 && super.canSpawnHere();
         }
         return false;
     }
 
     @Override
-	public int getTalkInterval()
+	public int getAmbientSoundInterval()
     {
         return 120;
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java b/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java
new file mode 100644
index 000000000..1fb5661bb
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java
@@ -0,0 +1,101 @@
+package net.minecraft.core.entity.animal;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.world.World;
+
+public class ChickenMob extends Animal
+{
+    public float flap;
+    public float flapSpeed;
+    public float oFlapSpeed;
+    public float oFlap;
+    public float flapping;
+    public int eggTimer;
+
+    public ChickenMob(World world)
+    {
+        super(world);
+        flap = 0.0F;
+        flapSpeed = 0.0F;
+        flapping = 1.0F;
+        textureIdentifier = new NamespaceID("minecraft", "chicken");
+        setSize(0.4F, 0.8F);
+        eggTimer = random.nextInt(6000) + 6000;
+        mobDrops.add(new WeightedRandomLootObject(Items.FEATHER_CHICKEN.getDefaultStack(), 0, 2));
+    }
+    @Override
+    public int getMaxHealth(){
+        return 4;
+    }
+
+    @Override
+	public void onLivingUpdate()
+    {
+        super.onLivingUpdate();
+        oFlap = flap;
+        oFlapSpeed = flapSpeed;
+        flapSpeed += (onGround ? -1 : 4) * 0.3D;
+        if(flapSpeed < 0.0F)
+        {
+            flapSpeed = 0.0F;
+        }
+        if(flapSpeed > 1.0F)
+        {
+            flapSpeed = 1.0F;
+        }
+        if(!onGround && flapping < 1.0F)
+        {
+            flapping = 1.0F;
+        }
+        flapping *= 0.9D;
+        if(!onGround && yd < 0.0D)
+        {
+            yd *= 0.6D;
+        }
+        flap += flapping * 2.0F;
+        if(!world.isClientSide && --eggTimer <= 0)
+        {
+            world.playSoundAtEntity(null, this, "mob.chickenplop", 1.0F, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+            spawnAtLocation(Items.EGG_CHICKEN.id, 1);
+            eggTimer = random.nextInt(6000) + 6000;
+        }
+    }
+
+    @Override
+	protected void causeFallDamage(float distance)
+    {
+    }
+
+    @Override
+	public void addAdditionalSaveData(CompoundTag tag)
+    {
+        super.addAdditionalSaveData(tag);
+    }
+
+    @Override
+	public void readAdditionalSaveData(CompoundTag tag)
+    {
+        super.readAdditionalSaveData(tag);
+    }
+
+    @Override
+    public String getLivingSound()
+    {
+        return "mob.chicken";
+    }
+
+    @Override
+	protected String getHurtSound()
+    {
+        return "mob.chickenhurt";
+    }
+
+    @Override
+	protected String getDeathSound()
+    {
+        return "mob.chickenhurt";
+    }
+}
